# -*- coding: utf-8 -*-
from setuptools import setup

package_dir = \
{'': 'src'}

packages = \
['graphdb',
 'graphdb.graphdb_workbench',
 'graphdb.graphdb_workbench.api',
 'graphdb.graphdb_workbench.models',
 'graphdb.rdf4j',
 'graphdb.rdf4j.api',
 'graphdb.rdf4j.models']

package_data = \
{'': ['*']}

install_requires = \
['json-stream==1.3.0', 'requests>=2.27.1,<3.0.0', 'swagger-to==4.1.1']

setup_kwargs = {
    'name': 'graphdb python',
    'version': '0.0.3',
    'description': 'test this',
    'long_description': '# GraphDB Python API\n\nNo description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)\n\nThis Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:\n\n- API version: 2.0\n- Package version: 1.0.0\n- Build package: io.swagger.codegen.languages.PythonClientCodegen\n\n## Requirements.\n\nPython 2.7 and 3.4+\n\n## Installation & Usage\n### pip install\n\n\n```sh\npip install git+https://github.com/patzomir/graphdb-python-api.git\n```\n(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/patzomir/graphdb-python-api.git`)\n\nThen import the package:\n```python\nimport graphdb\n```\n\n### Setuptools\n\nInstall via [Setuptools](http://pypi.python.org/pypi/setuptools).\n\n```sh\npython setup.py install --user\n```\n(or `sudo python setup.py install` to install the package for all users)\n\nThen import the package:\n```python\nimport graphdb\n```\n\n## Getting Started\n\nPlease follow the [installation procedure](#installation--usage) and then run the following:\n\n### RDF4J API\n\n```python\nfrom __future__ import print_function\nimport time\nfrom graphdb import rdf4j\nfrom graphdb.rdf4j.rest import ApiException\nfrom pprint import pprint\n\n# create an instance of the API class\napi_instance = rdf4j.ContextsApi(rdf4j.ApiClient(configuration))\nrepository_id = \'repository_id_example\' # str | The repository ID\n\ntry:\n    # Gets a list of resources that are used as context identifiers.\n    api_response = api_instance.get_repository_contexts(repository_id)\n    pprint(api_response)\nexcept ApiException as e:\n    print("Exception when calling ContextsApi->get_repository_contexts: %s\\n" % e)\n\n```\n\n### GraphDB Workbench API\n```python\nfrom __future__ import print_function\nimport time\nimport swagger_client\nfrom swagger_client.rest import ApiException\nfrom pprint import pprint\n\n# create an instance of the API class\napi_instance = swagger_client.ClusterManagementControllerApi(swagger_client.ApiClient(configuration))\nbean = swagger_client.WorkerCloneBean() # WorkerCloneBean | bean\n\ntry:\n    # Clone a worker\n    api_response = api_instance.clone_worker_using_post(bean)\n    pprint(api_response)\nexcept ApiException as e:\n    print("Exception when calling ClusterManagementControllerApi->clone_worker_using_post: %s\\n" % e)\n\n```\n## Documentation for API Endpoints\n\nAll URIs are relative to *https://localhost*\n\n### RDF4J\n\nClass | Method | HTTP request | Description\n------------ | ------------- | ------------- | -------------\n*ContextsApi* | [**get_repository_contexts**](docs/rdf4j/ContextsApi.md#get_repository_contexts) | **GET** /repositories/{repositoryID}/contexts | Gets a list of resources that are used as context identifiers.\n*GraphStoreApi* | [**add_statements_to_indirect_namedgraph**](docs/rdf4j/GraphStoreApi.md#add_statements_to_indirect_namedgraph) | **POST** /repositories/{repositoryID}/rdf-graphs/service | Add statements to an INDIRECTLY referenced named graph\n*GraphStoreApi* | [**add_statements_to_namedgraph**](docs/rdf4j/GraphStoreApi.md#add_statements_to_namedgraph) | **POST** /repositories/{repositoryID}/rdf-graphs/{graph} | Add statements to a DIRECTLY referenced named graph\n*GraphStoreApi* | [**delete_statements_from_indirect_namedgraph**](docs/rdf4j/GraphStoreApi.md#delete_statements_from_indirect_namedgraph) | **DELETE** /repositories/{repositoryID}/rdf-graphs/service | Clear an INDIRECTLY referenced named graph\n*GraphStoreApi* | [**delete_statements_from_namedgraph**](docs/rdf4j/GraphStoreApi.md#delete_statements_from_namedgraph) | **DELETE** /repositories/{repositoryID}/rdf-graphs/{graph} | Clear a DIRECTLY referenced named graph\n*GraphStoreApi* | [**get_all_statements_from_indirect_namedgraph**](docs/rdf4j/GraphStoreApi.md#get_all_statements_from_indirect_namedgraph) | **GET** /repositories/{repositoryID}/rdf-graphs/service | Fetch all statements from an INDIRECTLY referenced named graph\n*GraphStoreApi* | [**get_all_statements_from_namedgraph**](docs/rdf4j/GraphStoreApi.md#get_all_statements_from_namedgraph) | **GET** /repositories/{repositoryID}/rdf-graphs/{graph} | Fetch all statements from a DIRECTLY referenced named graph\n*NamespacesApi* | [**delete_namespace_for_prefix**](docs/rdf4j/NamespacesApi.md#delete_namespace_for_prefix) | **DELETE** /repositories/{repositoryID}/namespaces/{namespacesPrefix} | Remove namespace for a particular prefix\n*NamespacesApi* | [**get_namespace_for_prefix**](docs/rdf4j/NamespacesApi.md#get_namespace_for_prefix) | **GET** /repositories/{repositoryID}/namespaces/{namespacesPrefix} | Get namespace for a particular prefix\n*NamespacesApi* | [**set_namespace_for_prefix**](docs/rdf4j/NamespacesApi.md#set_namespace_for_prefix) | **PUT** /repositories/{repositoryID}/namespaces/{namespacesPrefix} | Set namespace for a particular prefix\n*ProtocolApi* | [**get_protocol_version**](docs/rdf4j/ProtocolApi.md#get_protocol_version) | **GET** /protocol | Fetch the protocol version\n*RepositoriesApi* | [**delete_repository**](docs/rdf4j/RepositoriesApi.md#delete_repository) | **DELETE** /repositories/{repositoryID} | Repository removal\n*RepositoriesApi* | [**delete_statements**](docs/rdf4j/RepositoriesApi.md#delete_statements) | **DELETE** /repositories/{repositoryID}/statements | Deletes statements from the repository.\n*RepositoriesApi* | [**get_all_repositories**](docs/rdf4j/RepositoriesApi.md#get_all_repositories) | **GET** /repositories | An overview of the repositories that are available on a server.\n*RepositoriesApi* | [**get_all_statements**](docs/rdf4j/RepositoriesApi.md#get_all_statements) | **GET** /repositories/{repositoryID}/statements | Fetches statements from the repository.\n*RepositoriesApi* | [**get_repository_size**](docs/rdf4j/RepositoriesApi.md#get_repository_size) | **GET** /repositories/{repositoryID}/size | The repository size (defined as the number of statements it contains)\n*RepositoriesApi* | [**put_statements**](docs/rdf4j/RepositoriesApi.md#put_statements) | **PUT** /repositories/{repositoryID}/statements | Updates data in the repository, replacing any existing data with the supplied data\n*SparqlApi* | [**execute_get_select_query**](docs/rdf4j/SparqlApi.md#execute_get_select_query) | **GET** /repositories/{repositoryID} | Send queries on a specific repository with ID. This resource represents a SPARQL query endpoint\n*SparqlApi* | [**update**](docs/rdf4j/SparqlApi.md#update) | **POST** /repositories/{repositoryID}/statements | Performs updates on the data in the repository\n*TransactionsApi* | [**execute_transaction_action**](docs/rdf4j/TransactionsApi.md#execute_transaction_action) | **PUT** /repositories/{repositoryID}/transactions/{transactionID} | Execute a transaction action\n*TransactionsApi* | [**rollback_transaction**](docs/rdf4j/TransactionsApi.md#rollback_transaction) | **DELETE** /repositories/{repositoryID}/transactions/{transactionID} | Abort a transaction\n*TransactionsApi* | [**start_new_transaction**](docs/rdf4j/TransactionsApi.md#start_new_transaction) | **POST** /repositories/{repositoryID}/transactions | Start a new transaction\n\n### GraphDB Workbench\n\nClass | Method | HTTP request | Description\n------------ | ------------- | ------------- | -------------\n*ClusterManagementControllerApi* | [**clone_worker_using_post**](docs/graphdb_workbench/ClusterManagementControllerApi.md#clone_worker_using_post) | **POST** /rest/cluster/nodes/clone | Clone a worker\n*ClusterManagementControllerApi* | [**connect_masters_using_post**](docs/graphdb_workbench/ClusterManagementControllerApi.md#connect_masters_using_post) | **POST** /rest/cluster/masters/{masterRepositoryId}/peers | Connect two masters\n*ClusterManagementControllerApi* | [**connect_worker_using_post**](docs/graphdb_workbench/ClusterManagementControllerApi.md#connect_worker_using_post) | **POST** /rest/cluster/masters/{masterRepositoryId}/workers | Connect a worker to a master\n*ClusterManagementControllerApi* | [**disconnect_masters_using_delete**](docs/graphdb_workbench/ClusterManagementControllerApi.md#disconnect_masters_using_delete) | **DELETE** /rest/cluster/masters/{masterRepositoryId}/peers | Disconnect two masters\n*ClusterManagementControllerApi* | [**disconnect_worker_using_delete**](docs/graphdb_workbench/ClusterManagementControllerApi.md#disconnect_worker_using_delete) | **DELETE** /rest/cluster/masters/{masterRepositoryId}/workers | Disconnect a worker from a master\n*ClusterManagementControllerApi* | [**do_backup_using_get**](docs/graphdb_workbench/ClusterManagementControllerApi.md#do_backup_using_get) | **GET** /rest/cluster/masters/{masterRepositoryId}/backup | Initiate a cluster backup\n*ClusterManagementControllerApi* | [**do_restore_using_get**](docs/graphdb_workbench/ClusterManagementControllerApi.md#do_restore_using_get) | **GET** /rest/cluster/masters/{masterRepositoryId}/restore | Initiate a cluster restore\n*ClusterManagementControllerApi* | [**get_master_using_get**](docs/graphdb_workbench/ClusterManagementControllerApi.md#get_master_using_get) | **GET** /rest/cluster/masters/{masterRepositoryId} | Get information about a master\n*ClusterManagementControllerApi* | [**get_workers_for_master_using_get**](docs/graphdb_workbench/ClusterManagementControllerApi.md#get_workers_for_master_using_get) | **GET** /rest/cluster/masters/{masterRepositoryId}/workers | Get workers connected to a master\n*ClusterManagementControllerApi* | [**set_master_using_post**](docs/graphdb_workbench/ClusterManagementControllerApi.md#set_master_using_post) | **POST** /rest/cluster/masters/{masterRepositoryId} | Set master attribute\n*ImportControllerApi* | [**import_server_file_using_post**](docs/graphdb_workbench/ImportControllerApi.md#import_server_file_using_post) | **POST** /rest/data/import/server/{repositoryID} | Import a server file into the repository\n*ImportControllerApi* | [**import_url_upload_using_post**](docs/graphdb_workbench/ImportControllerApi.md#import_url_upload_using_post) | **POST** /rest/data/import/upload/{repositoryID}/url | Import from data URL into the repository\n*ImportControllerApi* | [**interrupt_server_import_using_delete**](docs/graphdb_workbench/ImportControllerApi.md#interrupt_server_import_using_delete) | **DELETE** /rest/data/import/server/{repositoryID} | Cancel server file import operation\n*ImportControllerApi* | [**list_server_files_using_get**](docs/graphdb_workbench/ImportControllerApi.md#list_server_files_using_get) | **GET** /rest/data/import/server/{repositoryID} | Get server files available for import\n*LocationManagementControllerApi* | [**activate_location_using_post**](docs/graphdb_workbench/LocationManagementControllerApi.md#activate_location_using_post) | **POST** /rest/locations/activate | Activate a connected GraphDB location\n*LocationManagementControllerApi* | [**add_location_using_post**](docs/graphdb_workbench/LocationManagementControllerApi.md#add_location_using_post) | **POST** /rest/locations | Connect to a remote GraphDB location\n*LocationManagementControllerApi* | [**change_location_using_put**](docs/graphdb_workbench/LocationManagementControllerApi.md#change_location_using_put) | **PUT** /rest/locations | Modify settings for a connected GraphDB location\n*LocationManagementControllerApi* | [**delete_location_using_delete**](docs/graphdb_workbench/LocationManagementControllerApi.md#delete_location_using_delete) | **DELETE** /rest/locations | Disconnect a GraphDB location\n*LocationManagementControllerApi* | [**get_active_location_using_get**](docs/graphdb_workbench/LocationManagementControllerApi.md#get_active_location_using_get) | **GET** /rest/locations/active | Get active connected GraphDB location\n*LocationManagementControllerApi* | [**get_all_using_get**](docs/graphdb_workbench/LocationManagementControllerApi.md#get_all_using_get) | **GET** /rest/locations | Get all connected GraphDB locations\n*LocationManagementControllerApi* | [**set_default_repository_using_post**](docs/graphdb_workbench/LocationManagementControllerApi.md#set_default_repository_using_post) | **POST** /rest/locations/active/default-repository | Set default repository for active GraphDB location\n*RepositoryManagementControllerApi* | [**create_repository_using_post**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#create_repository_using_post) | **POST** /rest/repositories | Create a repository in an attached Sesame location (ttl file)\n*RepositoryManagementControllerApi* | [**delete_repository_using_delete**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#delete_repository_using_delete) | **DELETE** /rest/repositories/{repositoryID} | Delete a repository in an attached Sesame location\n*RepositoryManagementControllerApi* | [**download_repository_config_turtle_using_get**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#download_repository_config_turtle_using_get) | **GET** /rest/repositories/{repositoryID}/download | Download repository configuration as a Turtle file\n*RepositoryManagementControllerApi* | [**download_repository_config_zip_using_get**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#download_repository_config_zip_using_get) | **GET** /rest/repositories/{repositoryID}/downloadZip | Download repository configuration as a zip file\n*RepositoryManagementControllerApi* | [**edit_repository_using_put**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#edit_repository_using_put) | **PUT** /rest/repositories/{repositoryID} | Edit repository configuration\n*RepositoryManagementControllerApi* | [**get_default_config_using_get**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#get_default_config_using_get) | **GET** /rest/repositories/defaultConfig/{repositoryType} | Get the default repository configuration for the repository type\n*RepositoryManagementControllerApi* | [**get_repositories_using_get**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#get_repositories_using_get) | **GET** /rest/repositories | Get all repositories in the active location or another location\n*RepositoryManagementControllerApi* | [**get_repository_config_json_using_get**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#get_repository_config_json_using_get) | **GET** /rest/repositories/{repositoryID} | Get repository configuration as JSON\n*RepositoryManagementControllerApi* | [**repository_size_using_get**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#repository_size_using_get) | **GET** /rest/repositories/{repositoryID}/size | Get repository size\n*RepositoryManagementControllerApi* | [**restart_repository_using_post**](docs/graphdb_workbench/RepositoryManagementControllerApi.md#restart_repository_using_post) | **POST** /rest/repositories/{repositoryID}/restart | Restart a repository\n*SavedQueriesControllerApi* | [**create_query_using_post**](docs/graphdb_workbench/SavedQueriesControllerApi.md#create_query_using_post) | **POST** /rest/sparql/saved-queries | Create a new saved query\n*SavedQueriesControllerApi* | [**delete_sample_query_using_delete**](docs/graphdb_workbench/SavedQueriesControllerApi.md#delete_sample_query_using_delete) | **DELETE** /rest/sparql/saved-queries | Delete an existing saved query\n*SavedQueriesControllerApi* | [**edit_sample_query_using_put**](docs/graphdb_workbench/SavedQueriesControllerApi.md#edit_sample_query_using_put) | **PUT** /rest/sparql/saved-queries | Edit an existing saved query\n*SavedQueriesControllerApi* | [**get_queries_using_get**](docs/graphdb_workbench/SavedQueriesControllerApi.md#get_queries_using_get) | **GET** /rest/sparql/saved-queries | Get all saved queries visible for the user or single saved query by name and owner.\n*SecurityManagementControllerApi* | [**change_user_settings_using_patch**](docs/graphdb_workbench/SecurityManagementControllerApi.md#change_user_settings_using_patch) | **PATCH** /rest/security/user/** | Change settings for a user\n*SecurityManagementControllerApi* | [**create_user_using_post**](docs/graphdb_workbench/SecurityManagementControllerApi.md#create_user_using_post) | **POST** /rest/security/user/** | Create a user\n*SecurityManagementControllerApi* | [**delete_user_using_delete**](docs/graphdb_workbench/SecurityManagementControllerApi.md#delete_user_using_delete) | **DELETE** /rest/security/user/** | Delete a user\n*SecurityManagementControllerApi* | [**edit_user_using_put**](docs/graphdb_workbench/SecurityManagementControllerApi.md#edit_user_using_put) | **PUT** /rest/security/user/** | Edit a user\n*SecurityManagementControllerApi* | [**get_all_users_using_get**](docs/graphdb_workbench/SecurityManagementControllerApi.md#get_all_users_using_get) | **GET** /rest/security/user | Get all users\n*SecurityManagementControllerApi* | [**get_user_using_get**](docs/graphdb_workbench/SecurityManagementControllerApi.md#get_user_using_get) | **GET** /rest/security/user/** | Get a user\n*SecurityManagementControllerApi* | [**is_enabled_free_access_using_get**](docs/graphdb_workbench/SecurityManagementControllerApi.md#is_enabled_free_access_using_get) | **GET** /rest/security/freeaccess | Check if free access is enabled\n*SecurityManagementControllerApi* | [**is_enabled_security_using_get**](docs/graphdb_workbench/SecurityManagementControllerApi.md#is_enabled_security_using_get) | **GET** /rest/security | Check if security is enabled\n*SecurityManagementControllerApi* | [**set_enable_free_access_using_post**](docs/graphdb_workbench/SecurityManagementControllerApi.md#set_enable_free_access_using_post) | **POST** /rest/security/freeaccess | Enable or disable free access\n*SecurityManagementControllerApi* | [**set_enable_security_using_post**](docs/graphdb_workbench/SecurityManagementControllerApi.md#set_enable_security_using_post) | **POST** /rest/security | Enable or disable security\n*SparqlTemplateControllerApi* | [**create_sparql_template_using_post**](docs/graphdb_workbench/SparqlTemplateControllerApi.md#create_sparql_template_using_post) | **POST** /rest/sparql-template/create | Create a new SPARQL template\n*SparqlTemplateControllerApi* | [**delete_sparql_template_using_delete**](docs/graphdb_workbench/SparqlTemplateControllerApi.md#delete_sparql_template_using_delete) | **DELETE** /rest/sparql-template/delete | Delete an existing SPARQL template\n*SparqlTemplateControllerApi* | [**get_sparql_template_content_using_get**](docs/graphdb_workbench/SparqlTemplateControllerApi.md#get_sparql_template_content_using_get) | **GET** /rest/sparql-template/configuration | Get a SPARQL template configuration\n*SparqlTemplateControllerApi* | [**get_sparql_template_i_ds_using_get**](docs/graphdb_workbench/SparqlTemplateControllerApi.md#get_sparql_template_i_ds_using_get) | **GET** /rest/sparql-template | Get IDs of all configured SPARQL templates per current active repository\n*SparqlTemplateControllerApi* | [**update_sparql_template_using_put**](docs/graphdb_workbench/SparqlTemplateControllerApi.md#update_sparql_template_using_put) | **PUT** /rest/sparql-template/edit | Edit an existing SPARQL template\n*SqlViewsControllerApi* | [**create_sql_view_using_post**](docs/graphdb_workbench/SqlViewsControllerApi.md#create_sql_view_using_post) | **POST** /rest/sql-views/tables | Create a new SQL view\n*SqlViewsControllerApi* | [**delete_sql_view_using_delete**](docs/graphdb_workbench/SqlViewsControllerApi.md#delete_sql_view_using_delete) | **DELETE** /rest/sql-views/tables/{name} | Delete an existing saved query\n*SqlViewsControllerApi* | [**get_sql_view_names_using_get**](docs/graphdb_workbench/SqlViewsControllerApi.md#get_sql_view_names_using_get) | **GET** /rest/sql-views/tables | Get all SQL view names for current repository.\n*SqlViewsControllerApi* | [**get_sql_view_using_get**](docs/graphdb_workbench/SqlViewsControllerApi.md#get_sql_view_using_get) | **GET** /rest/sql-views/tables/{name} | Get a SQL view configuration.\n*SqlViewsControllerApi* | [**update_sql_view_using_put**](docs/graphdb_workbench/SqlViewsControllerApi.md#update_sql_view_using_put) | **PUT** /rest/sql-views/tables/{name} | Edit an existing SQL view\n*StatelessLoginControllerApi* | [**login_using_post**](docs/graphdb_workbench/StatelessLoginControllerApi.md#login_using_post) | **POST** /rest/login/** | Authenticate user with a password\n\n\n## Documentation For Models\n\n - [AccessBean](docs/graphdb_workbench/AccessBean.md)\n - [Account](docs/graphdb_workbench/Account.md)\n - [DefaultRepositoryLocation](docs/graphdb_workbench/DefaultRepositoryLocation.md)\n - [GraphDBRepository](docs/graphdb_workbench/GraphDBRepository.md)\n - [ImportSettings](docs/graphdb_workbench/ImportSettings.md)\n - [Location](docs/graphdb_workbench/Location.md)\n - [LocationUri](docs/graphdb_workbench/LocationUri.md)\n - [MasterConnectBean](docs/graphdb_workbench/MasterConnectBean.md)\n - [MasterNode](docs/graphdb_workbench/MasterNode.md)\n - [OwlimParameter](docs/graphdb_workbench/OwlimParameter.md)\n - [ParserSettings](docs/graphdb_workbench/ParserSettings.md)\n - [RepositoryConfigBean](docs/graphdb_workbench/RepositoryConfigBean.md)\n - [RepositorySizeInfo](docs/graphdb_workbench/RepositorySizeInfo.md)\n - [SavedQuery](docs/graphdb_workbench/SavedQuery.md)\n - [ServerImportBody](docs/graphdb_workbench/ServerImportBody.md)\n - [SparqlTemplate](docs/graphdb_workbench/SparqlTemplate.md)\n - [SqlColumn](docs/graphdb_workbench/SqlColumn.md)\n - [SqlView](docs/graphdb_workbench/SqlView.md)\n - [UpdatedLocation](docs/graphdb_workbench/UpdatedLocation.md)\n - [UserDetails](docs/graphdb_workbench/UserDetails.md)\n - [WorkerCloneBean](docs/graphdb_workbench/WorkerCloneBean.md)\n - [WorkerConnectBean](docs/graphdb_workbench/WorkerConnectBean.md)\n - [WorkerNode](docs/graphdb_workbench/WorkerNode.md)\n\n\n## Documentation For Authorization\n\n All endpoints do not require authorization.\n\n\n## Author\n\n\n\n',
    'author': 'Plamen Tarkalanov',
    'author_email': 'plamen.tarkalanov@ontotext.com',
    'maintainer': None,
    'maintainer_email': None,
    'url': None,
    'package_dir': package_dir,
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.8,<4.0',
}


setup(**setup_kwargs)
